#include "chip.h"
#include <stdlib.h>

typedef struct {
    t_chip_per_id id;
    __IO uint32_t *clk_reg;
    uint32_t clk_msk;
    __IO uint32_t *rst_reg;
    uint32_t rst_msk;
} t_per_regs;



static const t_per_regs f_per_regs[] = {
    /* AHB */
    {CHIP_PER_ID_DMA1,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_DMA1_EN,      NULL,                       0},
    {CHIP_PER_ID_SRAM,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_SRAM_EN,      NULL,                       0},
    {CHIP_PER_ID_CRC,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_CRC_EN,       NULL,                       0},
    {CHIP_PER_ID_USBFS,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_USBFS_EN,     &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_USBFS_RST},
    {CHIP_PER_ID_USBPD,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_USBPD_EN,     &CHIP_REGS_RCC->AHBRSTR,    CHIP_REGFLD_RCC_AHBRSTR_USBPD_RST},

    /* APB2 */
    {CHIP_PER_ID_AFIO,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_AFIO_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_AFIO_RST},
    {CHIP_PER_ID_GPIOA,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPA_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPA_RST},
    {CHIP_PER_ID_GPIOB,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPB_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPB_RST},
    {CHIP_PER_ID_GPIOC,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPC_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPC_RST},
    {CHIP_PER_ID_GPIOD,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_IOPD_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_IOPD_RST},
    {CHIP_PER_ID_ADC1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_ADC1_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_ADC1_RST},
    {CHIP_PER_ID_TIM1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM1_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM1_RST},
    {CHIP_PER_ID_SPI1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_SPI1_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_SPI1_RST},    
    {CHIP_PER_ID_USART1,    &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_USART1_EN,   &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_USART1_RST},
    /* APB1 */
    {CHIP_PER_ID_TIM2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM2_RST},
    {CHIP_PER_ID_TIM3,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM3_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM3_RST},
    {CHIP_PER_ID_TIM4,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM4_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM4_RST},
    {CHIP_PER_ID_WWDG,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_WWDG_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_WWDG_RST},
    {CHIP_PER_ID_SPI2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_SPI2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_SPI2_RST},
    {CHIP_PER_ID_USART2,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART2_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART2_RST},
    {CHIP_PER_ID_USART3,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART3_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART3_RST},
    {CHIP_PER_ID_USART4,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART4_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART4_RST},
    {CHIP_PER_ID_I2C1,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_I2C1_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_I2C1_RST},
    {CHIP_PER_ID_I2C2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_I2C2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_I2C2_RST},
    {CHIP_PER_ID_CAN1,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_CAN1_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_CAN1_RST},
    {CHIP_PER_ID_BKP,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_BKP_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_BKP_RST},
    {CHIP_PER_ID_PWR,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_PWR_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_PWR_RST},
    {CHIP_PER_ID_LPTIM1,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_LPTIM1_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_LPTIM1_RST},
};

static const t_per_regs *get_per_regs(t_chip_per_id id) {
    const t_per_regs *ret = 0;
    for (unsigned i = 0; i < sizeof(f_per_regs)/sizeof(f_per_regs[0]); i++) {
        if (f_per_regs[i].id == id) {
            ret = &f_per_regs[i];
            break;
        }
    }
    return ret;
}

void chip_per_rst(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->rst_reg) {
        *reg->rst_reg |= reg->rst_msk;
        chip_dmb();
        *reg->rst_reg &= ~reg->rst_msk;
        chip_dsb();
    }
}

void chip_per_clk_en(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg |= reg->clk_msk;
    }
}

void chip_per_clk_dis(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg &= ~reg->clk_msk;
    }
}

bool chip_per_clk_is_en(t_chip_per_id per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    return  reg && reg->clk_reg && ((*reg->clk_reg & reg->clk_msk) != 0);
}
